'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ConcatSource = require('webpack/lib/ConcatSource');

var _ConcatSource2 = _interopRequireDefault(_ConcatSource);

var _ExternalModuleFactoryPlugin = require('webpack/lib/ExternalModuleFactoryPlugin');

var _ExternalModuleFactoryPlugin2 = _interopRequireDefault(_ExternalModuleFactoryPlugin);

var _CustomUmdMainTemplatePlugin = require('./CustomUmdMainTemplatePlugin');

var _CustomUmdMainTemplatePlugin2 = _interopRequireDefault(_CustomUmdMainTemplatePlugin);

var _BuiltinModules = require('./BuiltinModules');

var _BuiltinModules2 = _interopRequireDefault(_BuiltinModules);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var platformRegexp = function platformRegexp(platforms) {
  return new RegExp('((' + platforms.join(')|(') + '))', 'i');
};

var getRequireQuery = function getRequireQuery(request) {
  var markIndex = request.indexOf('?');
  if (markIndex !== -1) {
    var query = _qs2.default.parse(request.substr(markIndex + 1));
    query.originRequest = request.substr(0, markIndex);
    return query;
  }
  return null;
};

var platformLoader = require.resolve('./PlatformLoader');

var platformWihteList = ['web', 'node', 'weex', 'reactnative'];

var RaxWebpackPlugin = function () {
  function RaxWebpackPlugin(options) {
    _classCallCheck(this, RaxWebpackPlugin);

    this.options = Object.assign({
      builtinModules: _BuiltinModules2.default,
      externalBuiltinModules: false,
      frameworkComment: null,
      includePolyfills: false,
      platforms: [], // web node weex reactnative
      polyfillModules: [],
      runMainModule: false,
      target: null
    }, options);
  }

  _createClass(RaxWebpackPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      // filter platforms by platformWihteList
      this.options.platforms = this.options.platforms.filter(function (platform) {
        var p = platform.toLowerCase();
        if (platformWihteList.indexOf(p) !== -1) {
          return true;
        }
        return false;
      });

      compiler.plugin('this-compilation', function (compilation) {
        compilation.apply(new _CustomUmdMainTemplatePlugin2.default(_this.options));
      });

      if (this.options.platforms && this.options.platforms.length !== 0) {
        (function () {
          var platforms = _this.options.platforms;

          compiler.plugin('entry-option', function (context, entry) {
            var entries = Object.keys(entry);

            // append platform entry
            entries.forEach(function (name) {
              platforms.forEach(function (p) {
                var platformType = p.toLowerCase();
                entry[name + '.' + platformType] = entry[name] + '?platform=' + platformType;
              });
            });

            _this.platformMatchRegexp = platformRegexp(platforms);
          });

          compiler.plugin('normal-module-factory', function (normalModuleFactory) {
            normalModuleFactory.plugin('after-resolve', function (data, callback) {
              var requireQuery = getRequireQuery(data.rawRequest);
              // has platform specified
              if (requireQuery) {
                (function () {
                  var platformQuery = '?platform=' + requireQuery.platform;

                  ['userRequest', 'rawRequest', 'resource'].forEach(function (key) {
                    // remove platform query string
                    data[key] = data[key].substring(0, data[key].length - platformQuery.length);
                  });

                  data.loaders.push('' + platformLoader + platformQuery);

                  data.request = data.loaders.join('!') + '!' + data.resource;
                })();
              }

              callback(null, data);
            });
          });
        })();
      }

      compiler.plugin('compile', function (params) {
        params.normalModuleFactory.apply(new _ExternalModuleFactoryPlugin2.default('amd', function (context, request, callback) {
          // @weex-module/* ignored
          if (/^@weex\-module\//.test(request)) {
            return callback(null, request, 'commonjs');
          }

          var builtinModuleName = _this.options.builtinModules[request];
          if (_this.options.externalBuiltinModules && builtinModuleName) {
            if (Array.isArray(builtinModuleName)) {
              var customRequest = '(function(){ var mod;';

              builtinModuleName.forEach(function (name) {
                customRequest += 'if (!mod) { try { mod = require("' + name + '") } catch(e) {} }';
              });

              customRequest += 'return mod;})()';
              // Custom external format
              return callback(null, customRequest, 'custom-format');
            } else {
              return callback(null, builtinModuleName, 'commonjs');
            }
          }

          callback();
        }));
      });

      if (this.options.target === 'bundle' || this.options.frameworkComment) {
        var defaultFrameworkComment = '// {"framework" : "Rax"}';
        var frameworkComment = typeof this.options.frameworkComment === 'string' ? this.options.frameworkComment : defaultFrameworkComment;

        compiler.plugin('compilation', function (compilation) {
          compilation.plugin('optimize-chunk-assets', function (chunks, callback) {
            chunks.forEach(function (chunk) {
              if (!chunk.initial) return;
              chunk.files.forEach(function (file) {
                compilation.assets[file] = new _ConcatSource2.default(frameworkComment, '\n', compilation.assets[file]);
              });
            });
            callback();
          });
        });
      }
    }
  }]);

  return RaxWebpackPlugin;
}();

RaxWebpackPlugin.BuiltinModules = _BuiltinModules2.default;

module.exports = RaxWebpackPlugin;